namespace CMSMicroservice.Application.ContractCQ.Commands.UpdateContract;
public class UpdateContractCommandValidator : AbstractValidator<UpdateContractCommand>
{
    public UpdateContractCommandValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
        RuleFor(model => model.Title)
            .NotEmpty();
        RuleFor(model => model.Description)
            .NotEmpty();
        RuleFor(model => model.HtmlContent)
            .NotEmpty();
        RuleFor(model => model.Type)
            .IsInEnum()
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<UpdateContractCommand>.CreateWithOptions((UpdateContractCommand)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
